program Item_5;

{$APPTYPE CONSOLE}

uses
  SysUtils;

type  TMyClass = class(TObject)
        m1: integer;
        mObj: TObject;
        constructor Create(aVal: integer);
        constructor InitOne;
        constructor InitTwo;
        destructor Destroy; virtual;
      end;

{ TMyClass }

constructor TMyClass.Create(aVal: integer);
begin
  inherited Create;
  mObj:= TObject.Create;
  m1:= aVal;
end;

destructor TMyClass.Destroy;
begin
  mObj.Free;
  inherited Destroy;
end;

constructor TMyClass.InitOne;
begin
  inherited Create;
  m1:= 1;
end;

constructor TMyClass.InitTwo;
begin
  inherited Create;
  m1:= 2;
end;

var X0, X1, X2 : TMyClass;

begin
  try
  X0:= TMyClass.Create(10);
  X0.Free;
  X1:= TMyClass.InitOne;
  X2:= TMyClass.InitTwo;
  Writeln(Assigned(X2));
  Readln;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
