program Set_03;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas';

//      

function MakeSet(const arg: string): TSet;
var i: integer;
    t: TItem;
begin
  Result:= CreateSet;   //   
  for i:= 1 to Length(arg) do begin
    t:= TItemChar.Create(UpCase(arg[i]));  //  -
    if not Result.Insert(t)  //      
      then t.Free;           //   
  end;
end;

procedure Show(arg: TCompare);
begin
  case arg of
    cmpEq:     Writeln('Eq');
    cmpLess:   Writeln('Less');
    cmpGreate: Writeln('Greate');
    cmpIncomp: Writeln('Incomp');
  end;
end;

var A, B, C, D : TSet;    //   

begin
  try
    //     
    A:= MakeSet('ABCD');
    B:= CreateSet;
    B.CopyItems(A);
    Show(A.Compare(B));  // Eq
    B:= MakeSet('BD');
    C:= MakeSet('DF');
    D:= MakeSet('FE');
    Show(A.Compare(B));  // Greate  A -  B
    Show(B.Compare(A));  // Less    B -  A
    Show(A.Compare(C));  // Incomp
    Show(A.Compare(D));  // Incomp
    //   
    Writeln(A.TestIntersect(B));  // TRUE - 
    Writeln(B.TestIntersect(A));  // TRUE - 
    Writeln(A.TestIntersect(D));  // FALSE -  
    Readln;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
