program Graph_27;
{
   
}
{$APPTYPE CONSOLE}

uses
  SysUtils,
  Assembly in '..\Common\Assembly.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas';

const CFile = 'Test_14d.txt';
//const CFile = 'Bin_5x5.txt';

var Gr : TGraph;
    S, T : TNode;
    Flow, MaxFlow: integer;
    Cost: integer;
//    st: string;

begin
  try
    Gr:= TGraphChars.Load(CFile);
    Gr.Expo;
    (Gr as TGraphChars).LoadFlowData(CFile);
    Writeln('= = = = = = = = =');
//    Gr.ExpoLinksData;
    S:= (Gr as TGraphChars).GetNode('A');
    T:= (Gr as TGraphChars).GetNode('G');
//Close(Output); Assign(Output,'OutCost2.txt'); Rewrite(Output);
    MaxFlow:= Gr.CalcMaxFlow0(S, T);
    Gr.ExpoLinksData;
    Writeln('=================');
    Writeln('MaxFlow= ', MaxFlow);
    repeat
        Write('Flow = '); Readln(Flow);
        Cost:= Gr.CalcMinCostFlow(S, T, Flow);
        Writeln('Cost= ', Cost);
        Gr.ExpoLinksData;
        Writeln('=================');
//Close(Output); Assign(Output,''); Rewrite(Output);
    //    Readln(st);
    until Flow=0;
    Gr.Free;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.

