program Graph_14c;
//////////////////////////////////////////////////////////////
//  ,
//       
// (  )

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas',
  Assembly in '..\Common\Assembly.pas';

var Gr1, Gr2 : TGraphChars;
    Node : TNode;
    Sub : TSet;
    S: string;

begin
  try
  repeat
    Gr1:= TGraphChars.GenRandom(true, 1, 1, 10, 50);
    Gr1.Expo;

    Writeln('- - - - - - - - - - - - - - - - - -');
    Writeln('Copy:');
    // :
    Gr2:= TGraphChars(Gr1.Copy);
    Gr2.Expo;
    Gr2.Free;

    Writeln('- - - - - - - - - - - - - - - - - -');
    Writeln('Copy and reverse:');
    //    :
    Gr2:= TGraphChars(Gr1.CopyGr(true));
    Gr2.Expo;
    Gr2.Free;

    Writeln('- - - - - - - - - - - - - - - - - -');
    Writeln('Copy by Nodes:');
    //    ():
    Sub:= CreateSet;
    Sub.Insert(Gr1.GetNode('A'));
    Sub.Insert(Gr1.GetNode('C'));
    Sub.Insert(Gr1.GetNode('E'));
    Gr2:= TGraphChars(Gr1.CopyByNodes(Sub));
    Gr2.Expo;
    Gr2.Free;
    Sub.Free;

    Writeln('- - - - - - - - - - - - - - - - - -');
    Writeln('Copy by Links:');
    //   :
    Sub:= CreateSet;
    Node:= Gr1.GetNode('A');
    Sub.Insert(Node.OutLinkFirst);
    Node:= Gr1.GetNode('B');
    Sub.Insert(Node.OutLinkFirst);
    Gr2:= TGraphChars(Gr1.CopyByLinks(Sub));
    Gr2.Expo;
    Gr2.Free;
    Sub.Free;
    Writeln('- - - - - - - - - - - - - - - - - -');

    Gr1.Free;
    Readln(S);
  until S<>'';

  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
