program Graph_22a;
{
      
}
{$APPTYPE CONSOLE}

uses
  SysUtils,
  DateUtils,
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas',
  Assembly in '..\Common\Assembly.pas';

var Gr: TGraphChars;
    PCenters: TCostSet;
    Lambda : integer;
    Direct : TCenter;
begin
  try
//  Assign(Output,'Out-2.txt'); Rewrite(Output);

  Gr:= TGraphChars.Load('Test_4d.txt');
  //Gr:= TGraphChars.GenRandom(false, 10, 10, 20, 50);
  Gr.Expo;
  Writeln('- - - - - - - - - - - - - - - - - -');
  repeat
    Write('Lambda= '); Readln(Lambda);
    if Lambda = 0 then Break;
    if Lambda>0 then begin
      Writeln('- - - - - - - OUT CENTER - - - - - - - - - - -');
      Direct:= OutCenter;
    end else begin
      Writeln('- - - - - - -  IN CENTER - - - - - - - - - - -');
      Direct:= InCenter;
    end;
    PCenters:= Gr.GenPCentLambda(Abs(Lambda), Direct);
    if Assigned(PCenters) then begin
      Writeln('Lambda = ', Lambda);
      Writeln('- - - - - - - - - - - - - - - - - -');
      PCenters.Expo;
      PCenters.ClrAndDestroy;
      PCenters.Free;
    end;
  until false;
  //Close(Output);
  Gr.Free; //  
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
