program Graph_23b;
{
  P-
}

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Assembly in '..\Common\Assembly.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas';

type  TGrTest = class(TGraphChars)
        procedure GenCombin(aPole: integer);
      end;

var Gr: TGrTest;

//////////////////////////////////////////////////////////////
//      P 

procedure TGrTest.GenCombin(aPole: integer);
var
    S: TSet;          //  
    Level : integer;  //   - 1
    NN: integer;      //     
    Count : integer;  //  

  //     
  // aIndex -    

  procedure Local(aIndex: integer);
  var i: integer;
      N: TNode;        //  
  begin
    for i:= aIndex to NN do begin
      N:= mNodes.GetItem(i + Level) as TNode;  //    
      S.Insert(N);        //   
      if Level+1=aPole    //  ?
        then begin
          S.Expo;         // , 
          Inc(Count);     //   
        end
        else begin
          Inc(Level);     // ,  
          Local(i);       //   
          Dec(Level);     //    
        end;
      S.Delete(N);        //    
    end;
  end;

begin
  S:= CreateSet;   //    
  Count:=0;        //  
  Level:= 0;       //  
  //  ,    :
  NN:= mNodes.GetCount + 1 - aPole;
  Local(1);        //    
  Writeln('Count= ', Count);
  S.Free;
end;
//////////////////////////////////////////////////////////////

var P : integer;

begin
  try
    //Gr:= TGrTest.Load('Test_1.txt');
    Gr:= TGrTest.GenRandom(false, 10, 10, 7, 12);
    //Gr:= TGrTest.GenRandom(false, 10, 10, 18, 22);
    Gr.Expo;
    Writeln('- - - - - - - - - - - - - - - - - -');
    repeat
      Write('P= '); Readln(P);
      if P=0 then Break;
      Gr.GenCombin(P);
      Writeln('- - - - - - - - - - - - - - - - - -');
    until false;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
