program Graph_29a;
{
  .   
}
{$APPTYPE CONSOLE}

uses
  SysUtils, DateUtils,
  Assembly in '..\Common\Assembly.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas';

var Gr : TGraph;
    Res : TCostSet;
    Nodes: integer;

procedure Handle(arg: TPairs);
var Start: TDateTime;
    Time : integer;
begin
  Start:= Now;
  Res:= Gr.GenPairs(arg);
  Time:= MilliSecondsBetween(Start, Now);
  Res.Expo;
  Writeln('Nodes    = ', Gr.Nodes);
  Writeln('Time (ms)=', Time:6);
  Res.mSet.ClrAndDestroy;
  Res.Free;
end;

begin
  try
    repeat
      Write('Nodes= '); Readln(Nodes);
      if abs(Nodes) < 3 then Break;
      Gr:= TGraphChars.Load('Test-15.txt');
//      Gr:= TGraphChars.GenRandom(true, 0, 99, Nodes, -20 {%});
//      Gr:= TGraphChars.GenRandom(false, 0, 99, Nodes, -20 {%});
//      Gr:= TGraphChars.GenFull((Nodes>0), 0, 99, Abs(Nodes));

Assign(Output, 'Out-17a.txt');
if FileExists('Out-17a.txt')  then Append(Output)   else Rewrite(Output);

      Gr.Expo;
      Writeln('--------------- MaxN -----------------');
      Handle(pMaxN);
      Writeln('--------------- MinW -----------------');
      Handle(pMinW);
      Writeln('--------------- MaxW -----------------');
      Handle(pMaxW);
      Writeln('--------------------------------------');

Close(Output);  Assign(Output, '');    Rewrite(Output);

    until false;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.

